﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Documents.Model;
using System.Reflection;

namespace SilverlightApplication1
{
    public class CustomIfMergeField : MergeField
    {
        private const string CustomFieldName = "CustomIfMergeField";

        static CustomIfMergeField()
        {
            CodeBasedFieldFactory.RegisterFieldType(CustomIfMergeField.CustomFieldName, () => { return new CustomIfMergeField(); });
        }

        public override string FieldTypeName
        {
            get
            {
                return CustomIfMergeField.CustomFieldName;
            }
        }

        public override Field CreateInstance()
        {
            return new CustomIfMergeField();
        }

        protected override DocumentFragment GetResultFragment()
        {
            int valueCount = 0;

            if (this.Document != null && !string.IsNullOrEmpty(this.PropertyPath))
            {
                object currentItem = this.Document.MailMergeDataSource.CurrentItem;
                if (currentItem != null)
                {
                    // here you can cast directly to the type in your data source if it's statically known - it would be faster.
                    // something like:
                    // int valueCount =  ((MyDataSourceType)currentItem).Count;

                    object value = currentItem.GetType().GetProperty(this.PropertyPath).GetGetMethod().Invoke(currentItem, new object[0]);
                    if (value is int)
                    {
                        valueCount = (int)value;
                    }
                }
            }

            string valueAsString = null;
            if (valueCount != 0)
            {
                valueAsString = this.TextBeforeIfNotEmpty + this.TextAfterIfNotEmpty;
            }

            return base.CreateFragmentFromText(valueAsString);
        }
    }
}